% A demo for ps_sparse reconstruction 
clear all; close all; clc;

Np = 200;
Nf  = 256;
Nnav  = 4;
Numfr = 2048;
Ng = 8;
Nfr  = Numfr/Ng;

% load the phantom data
% image_xyt = load_image_std(data_local, Ng, Numfr);
load image_xyt.mat
Kraw = 1/sqrt(Np*Nf)*fft2(image_xyt);
image_xyt = reshape(image_xyt, Np*Nf, Nfr);
Kraw = reshape(Kraw, Np*Nf, Nfr);

% form the k-t space sampling mask 
Nsam = 32;
nav_ind = Np/2-Nnav/2+1:Np/2+Nnav/2;
temmask = tem_sampling_generation(Np, Nfr, Nnav, Nsam);
temmask = fftshift(temmask, 1);
Mask = permute(reshape(repmat(temmask, 1, Nf), Np, Nfr, Nf), [1, 3, 2]);
Mask = reshape(Mask, Np*Nf, Nfr); 
d = Kraw(Mask);

% determine the temporal subspace 
nav_location = zeros(Np, 1);
nav_location(nav_ind) = 1;
Kraw = reshape(Kraw, Np, Nf, Nfr);
Navdata = reshape(Kraw(find(fftshift(nav_location)), :, :), Nnav*Nf, Nfr);
r = 32;
[~, ~, Vt_r] = svds(Navdata, r);
Vt_r = Vt_r';

% determine the spatial subspace
fprintf('Model order %d Basic PS-Sparse reconstruction \n', r);
beta = 1e3;
mu   = 2.5e-6;
Us_r0 = zeros(Np*Nf, r);
Us_r = ps_sparse_recon(d, Mask, Us_r0, Vt_r, mu, beta, 'xf_sparse', Np, Nf, Nfr);
recon_pssp = Us_r*Vt_r;
recon_recerr = norm(image_xyt(:) - recon_pssp(:))/norm(image_xyt(:));



